#ifndef CPUM_H_INCLUDED
#define CPUM_H_INCLUDED

#include "device.h"
#include "ini.h"
#include "device/z80.h"


////////////////////////////////////////////////////////////////
// NX`
////////////////////////////////////////////////////////////////
class CPU6 : public Device, public cZ80, public IDoko {
private:
	BYTE Fetch( WORD, int * );		// tFb`(M1)
	
	BYTE ReadMemNW( WORD );			// ANZX(EFCgȂ)
	
	BYTE ReadMem( WORD );			// ANZX(EFCg) Read
	void WriteMem( WORD, BYTE );	// ANZX(EFCg) Write
	
	BYTE ReadIO( int );				// I/O|[gANZX Read
	void WriteIO( int, BYTE );		// I/O|[gANZX Write
	
	int GetIntrVector();			// ݃xN^擾
	
public:
	CPU6( VM6 *, const ID& );		// RXgN^
	~CPU6();						// fXgN^
	
	bool IsBUSREQ();				// BUSREQ擾
	
	// ------------------------------------------
	bool DokoSave( cIni * );	// ǂłSAVE
	bool DokoLoad( cIni * );	// ǂłLOAD
	// ------------------------------------------
};

#endif		// CPUM_H_INCLUDED
